<template>
  <div>
    <v-row class="justify-center">
      <v-col md="4" sm="12" class="pa-0" v-if="modoVista != 3">
        <div class="visor">
          <div>
            <div class="pa-2 visor__titulo">
              <h3>Evidencia Actual</h3>
              <label class="normal">{{ dataLateral.imagenes.length }} fotos</label>
            </div>
            <v-sheet v-if="dataLateral.status == 0" class="pa-2 txtMotivo">
              <span class="d-flex justify-space-between align-center mb-2">
                <h4>
                  <strong>Motivo de rechazo</strong>
                </h4>
                <small>{{detalleHallazgo.detalleHallazgo[0].fechaAutorizo}}</small>
              </span>
              <div class="tLeft">{{dataLateral.motivoRechazo}}</div>
            </v-sheet>
          </div>
          <div class="scroll">
            <div class="visor__lateral">
              <div v-for="(data, index) in dataLateral.imagenes" :key="index">
                <!-- <img :src="obtenerImgUrl(data.nombreImg, data.formatoImg)" > -->
                <img :src="getUrlImg(data.nombreImg, data.formatoImg)" />
              </div>
              <div class="comentariosVisor">
                <strong>Comentario</strong>
                <small>{{detalleHallazgo.detalleHallazgo[0].fechaIni}}</small>
                <span v-if="dataLateral.comentario != '' ">{{dataLateral.comentario}}</span>
                <span v-else>Sin comentarios.</span>
                <!--<div class="img__boton img__boton--zoom-arriba"  @click.stop="dialogEvidencia = true">-->
                <div class="img__boton img__boton--zoom-arriba" @click.stop="initImgVer()">
                  <img src="@/assets/img/visorFotografias/zoom.svg" />
                </div>
              </div>
            </div>
          </div>
        </div>
      </v-col>
      <v-col md="8" sm="12" class="pa-0">
        <div class="d-flex flex-column visor">
          <div class="pa-2 visor__titulo">
            <h3>Nueva evidencia</h3>
            <template v-if="archivosAtencion.length > 0">
              <div class="avanzar-img">
                <img
                  src="@/assets/img/icoAtras.svg"
                  @click="avanzarImg(1)"
                  v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"
                />
                <label>{{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }}</label>
                <img
                  src="@/assets/img/icoSiguiente.svg"
                  @click="avanzarImg(2)"
                  v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}"
                />
              </div>
              <label>{{ archivosAtencion.length }} fotos</label>
            </template>
          </div>
          <div class="visor__img-carousel" v-if="archivosAtencion.length > 0">
            <div class="img__container">
              <!-- <img :src="getEvidenciaHallazgo(archivosAtencion)"> -->
              <img
                v-if="modoVista !=1  || (modoVista == 1 && dataLateral.status == 0 && isFileSelected == false)"
                :src="getEvidenciaHallazgo(archivosAtencion)"
              />
              <img
                v-if="(modoVista ==1 && dataLateral.status == 1) || (modoVista ==1 && dataLateral.status == 0 && isFileSelected ) "
                :src="dataImage"
              />
              <div class="img__boton img__boton--zoom" @click.stop="dialogEvidenciaAtencion = true">
                <img src="@/assets/img/visorFotografias/zoom.svg" />
              </div>
              <div
                class="img__boton img__boton--eliminar"
                @click="eliminarImg(archivoSeleccionado.posicion)"
                v-if="isFileSelected == true"
              >
                <img src="@/assets/img/icoEliminarBlanco.svg" />
              </div>
            </div>
          </div>
          <div
            class="pa-4 ma-4 dragdrop"
            v-bind:class="{'dragdrop__agregar-archivo': entraDrag, 'flex-grow-1': archivosAtencion.length == 0}"
            @drop.prevent="agregarImg($event, 1)"
            @dragover.prevent="entraDrag = true"
            @dragleave.prevent="entraDrag = false"
            v-if="modoVista == 1 && !isFileSelected"
          >
            <input type="file" value="Elegir archivos" @change="agregarImg($event, 2)" />
            <img src="@/assets/img/visorFotografias/imagenAgregar.svg" />
            <template>
              <label class="text-center">
                Da clic aquí o arrastra archivos desde tu computadora
                <br />para agregar evidencias
              </label>
            </template>
            <v-alert class="mt-2" v-if="alertaImagen" dense outlined type="error">
              Necesitas elegir una
              <strong>imagen</strong>
            </v-alert>
          </div>

          <div class="pa-3 pb-0 visores__comentarios">
            <template v-if="modoVista == 1">
              <div class="d-flex align-center justify-space-between">
                Comentario
                <small class="red--text">{{caracteres}} caracteres</small>
              </div>
              <v-text-field
                hide-details
                maxlength="300"
                outlined
                solo
                background-color="white"
                placeholder="Ingrese un comentario..."
                v-model="observaciones"
                @input="countCharacters()"
              ></v-text-field>
              <v-alert class="mt-2" v-if="alertaComentario" dense outlined type="error">
                Necesitas ingresar un
                <strong>comentario</strong>
              </v-alert>
            </template>
            <div class="mb-4 px-2 comentariosVisor" v-if="modoVista != 1">
              <h4>
                <strong>Comentario</strong>
              </h4>
              <small class="mb-1">{{detalleHallazgo.detalleHallazgo[0].fechaAutorizo}}</small>
              <label>{{detalleHallazgo.detalleHallazgo[0].obsAtencion}}</label>
            </div>
          </div>
        </div>
      </v-col>
    </v-row>

    <!--Modal Nueva evidencia Hallazgos-->
    <v-dialog v-model="dialogEvidencia" max-width="600">
      <v-card>
        <div class="btnCerrarModal" @click="dialogEvidencia = false">
          <div>X</div>
        </div>
        <v-card-title class="headline">
          <div class="titModal">Evidencia Actual</div>
        </v-card-title>

        <div class="contModal tCenter">
          <!-- <img class="icoVisor" :src="obtenerImgUrl(archivoSeleccionado.nombreImg, archivoSeleccionado.formatoImg)"> -->
          <!-- <img class="icoVisor" :src="getEvidenciaHallazgo(archivos)"> -->
          <img class="icoVisor" :src="getImagen()" />

          <div class="pa-2 visor__titulo justify-center">
            <div class="avanzar-img">
              <img
                src="@/assets/img/icoAtras.svg"
                @click="avanzarImg(1,archivos)"
                v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"
              />
              <label>{{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }}</label>
              <img
                src="@/assets/img/icoSiguiente.svg"
                @click="avanzarImg(2,archivos)"
                v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}"
              />
            </div>
          </div>
          <div class="comentariosVisor">
            <strong>Comentario</strong>
            <small>{{detalleHallazgo.detalleHallazgo[0].fechaIni}}</small>
            <span>{{dataLateral.comentario}}</span>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <!--Modal Nueva evidencia de atencioan hallazgo Hallazgos-->
    <v-dialog v-model="dialogEvidenciaAtencion" max-width="600">
      <v-card>
        <div class="btnCerrarModal" @click="dialogEvidenciaAtencion = false">
          <div>X</div>
        </div>
        <v-card-title class="headline">
          <div class="titModal">Evidencia Atención</div>
        </v-card-title>

        <div class="contModal tCenter">
          <img class="icoVisor" v-if="isFileSelected" :src="dataImage" />
          <img
            class="icoVisor"
            v-if="isFileSelected == false"
            :src="getEvidenciaHallazgo(archivosAtencion)"
          />
          <!-- <img class="icoVisor" :src="getUrlImg(archivoSeleccionado.nombreImg, archivoSeleccionado.formatoImg)"> -->
          <div class="pa-2 visor__titulo justify-center">
            <div class="avanzar-img">
              <!-- <img src="@/assets/img/icoAtras.svg" @click="avanzarImg(1,archivosAtencion)" v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"> 
                                <label> {{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }} </label> 
              <img src="@/assets/img/icoSiguiente.svg" @click="avanzarImg(2,archivosAtencion)" v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}">-->

              <img
                src="@/assets/img/icoAtras.svg"
                v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"
              />
              <label>{{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }}</label>
              <img
                src="@/assets/img/icoSiguiente.svg"
                v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}"
              />
            </div>
          </div>
          <div class="comentariosVisor">
            <strong>Comentario</strong>
            <small>{{detalleHallazgo.detalleHallazgo[0].fechaAutorizo}}</small>
            <span v-if="isFileSelected == false">{{dataLateral.obsAtencion}}</span>
            <span v-if="isFileSelected">{{this.observaciones}}</span>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  name: "VisorFotografia",
  components: {},
  data: () => ({
    alertaComentario: false,
    alertaImagen: false,

    contador: 0,
    borraImg: false,

    //comentarios
    observaciones: "",
    motivoRechazo: "",
    caracteres: 300,

    archivos: [],
    archivosAtencion: [],
    dataImage: "",
    isFileSelected: false,
    comentario: "",
    entraDrag: false,
    archivoSeleccionado: {
      posicion: 0,
      nombreImg: "elektra5",
      formatoImg: "jpeg"
    },
    dialogEvidencia: false,
    dialogEvidenciaAtencion: false
  }),
  props: ["titulo", "dataLateral", "modoVista", "detalleHallazgo"],
  methods: {
    getImagen() {
      //return "http://10.51.218.104"+this.archivoSeleccionado.nombreImg+"."+this.archivoSeleccionado.formatoImg;
      return (
        "http://10.53.33.82" +
        this.archivoSeleccionado.nombreImg +
        "." +
        this.archivoSeleccionado.formatoImg
      );
    },
    validaCampos() {
      if (this.observaciones == "" || this.observaciones.length <= 0) {
        this.alertaComentario = true;
      } else {
        this.alertaComentario = false;
      }

      if (this.dataImage == "" || this.dataImage.length <= 0) {
        this.alertaImagen = true;
      } else {
        this.alertaImagen = false;
      }

      if (this.alertaImagen == false && this.alertaComentario == false)
        return true;
      else return false;
    },
    validaDatos() {
      var jsonObjet = {
        dataBase64: this.dataImage,
        observaciones: this.observaciones
      };

      return jsonObjet;
    },
    countCharacters() {
      this.caracteres = 300 - this.observaciones.length;

      if (this.observaciones.length > 0) {
        this.alertaComentario = false;
      } else {
        this.alertaComentario = true;
      }
    },
    initImgVer() {
      this.dialogEvidencia = true;

      this.archivoSeleccionado = {
        posicion: 0,
        nombreImg: this.archivos[0].nombreImg,
        formatoImg: "jpg"
      };
    },
    avanzarImg(accion, imagenes) {
      /**
       * 2 = adelante
       * 1 = atras
       */

      // if(accion == 1){
      //     this.archivoSeleccionado.posicion--;
      // }else{
      //     this.archivoSeleccionado.posicion++;
      // }

      // //Solo para representar el cambio de imagen
      // this.archivoSeleccionado.nombreImg = this.archivoSeleccionado.nombreImg == 'elektra5' ? 'elektra6' : 'elektra5';

      if (accion == 1) {
        this.contador--;
        this.contador = this.contador < 0 ? imagenes.length - 1 : this.contador;
      } else {
        this.contador++;
        this.contador = this.contador == imagenes.length ? 0 : this.contador;
      }

      const numImg =
        this.archivos.length > 0 ? this.archivosAtencion.length : 0;

      this.archivoSeleccionado.posicion = this.contador;
      this.archivoSeleccionado.nombreImg = imagenes[this.contador].nombreImg;
      this.archivoSeleccionado.formatoImg = imagenes[this.contador].formatoImg;
    },

    agregarImg(event, tipo) {
      let files = tipo == 1 ? event.dataTransfer.files : event.target.files;

      const img = new Image();
      const reader = new FileReader();

      reader.onload = e => {
        this.dataImage = e.target.result;
        this.isFileSelected = true;
        this.archivosAtencion.splice(0, 1);
        this.archivosAtencion.push(this.dataImage);
        this.borraImg = true;
      };

      reader.readAsDataURL(files[0]);

      // for(let key of Object.keys(files)){
      //     //this.archivos = [...this.archivos, files[key]];
      //    this.archivosAtencion.push()
      // }
    },
    eliminarImg(posicion) {
      this.isFileSelected = false;
      this.archivosAtencion.splice(0, 1);

      if (this.originalAtencion != null) {
        this.archivosAtencion.push(this.originalAtencion);
      }

      //alert("EL nuevo array es: "+JSON.stringify(this.archivosAtencion));

      //this.archivoSeleccionado.posicion = posicion > 0 ? posicion - 1 : 0;
      //this.archivoSeleccionado.nombreImg = this.archivoSeleccionado.nombreImg == 'elektra5' ? 'elektra6' : 'elektra5';
    },

    obtenerImgUrl(imgNombre, imgFormato) {
      return require("@/assets/img/visorFotografias/" +
        imgNombre +
        "." +
        imgFormato);
    },
    getUrlImg(nombreImg, formatoImg) {
      //return "http://10.51.218.104"+nombreImg+"."+formatoImg;

      let liga = ("http://10.53.33.82" + nombreImg + "." + formatoImg).replace(
        "\n",
        ""
      );

      return liga;
    },
    getEvidenciaHallazgo(archivos) {
      if (archivos != null && archivos.length > 0) {
        //return "http://10.51.218.104"+archivos[0].nombreImg+"."+archivos[0].formatoImg;
        let liga = (
          "http://10.53.33.82" +
          archivos[0].nombreImg +
          "." +
          archivos[0].formatoImg
        ).replace("\n", "");

        return liga;
      }
    },
    getImgAtencionHallazgo() {
      return this.archivosAtencion[0];
    }
  },
  created() {
    /*
        if(+this.modoVista == 2 || +this.modoVista == 3){
            this.comentario = this.dataLateral.comentario;
            this.archivos = [
                'elektra1.jpg',
                'elektra2.jpg',
                'elektra3.jpg',
                'elektra4.jpg',
            ]
        }*/

    this.archivos = this.dataLateral.imagenes;
    this.archivosAtencion = this.dataLateral.imagenes_atencion;

    this.originalAtencion =
      this.dataLateral.imagenes_atencion.length > 0
        ? this.dataLateral.imagenes_atencion[0]
        : null;

    //alert(JSON.stringify(this.archivosAtencion));
    // alert("El tamaño de archivos atencion"+this.archivosAtencion.length);

    //this.archivosAtencion = [];

    this.contador = 0;
  }
};
</script>
<style scoped>
.visor {
  background-color: #ffff;
  height: 100%;
  padding: 10px 3%;
  margin-right: 20px;
}

.visor__lateral {
  max-height: 46rem;
  overflow: auto;
}

.visor__lateral > img {
  width: 100%;
  height: auto;
  margin: 0px auto 10px auto;
}

.visor__titulo {
  background-color: #ffffff;
  border-bottom: 2px solid lightgray;
  margin-bottom: 20px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  font-family: "Avenir_Next_Demi_Bold";
}

.visor__img-carousel {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0 1rem;
  position: relative;
}

.img__container {
  position: relative;
  width: 50%;
  max-width: 100%;
}

.img__container > img {
  display: block;
  width: 100%;
  height: auto;
  margin: auto;
}

.img__boton {
  position: absolute;
  opacity: 1;
  height: 1.7rem;
  width: 1.7rem;
  margin: 1rem;
  border-radius: 50%;
  display: flex;
  align-items: center;
  justify-content: center;
  cursor: pointer;
}

.img__boton > img {
  height: 1rem;
  width: 1rem;
}

.img__boton--zoom {
  bottom: 0;
  right: 0;
  background-color: var(--main-bg-color);
}

.img__boton--zoom-arriba {
  top: -15px;
  right: -10px;
  background-color: var(--main-bg-color);
}

.img__boton--eliminar {
  top: -0.7rem;
  right: -0.7rem;
  margin: 0;
  background-color: #575757;
}

.dragdrop {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  /*border: 2px dashed var(--main-bg-color);*/
  border: 2px dashed #c2c2c2;
  border-radius: 1rem;
  position: relative;
  max-height: 46rem;
}

.dragdrop__agregar-archivo {
  border: 2px dashed var(--main-color);
}

.dragdrop > input[type="file"] {
  width: 100%;
  height: 100%;
  position: absolute;
  opacity: 0;
  cursor: pointer;
}

.dragdrop > img {
  height: 7rem;
  margin-bottom: 1rem;
}

.dragdrop > label {
  font-size: 1rem;
}

/*---------------------------*/

.visores {
  display: flex;
  align-items: center;
  align-items: stretch;
}

.visores__visor {
  display: flex;
  text-align: center;
  justify-content: center;
  flex-direction: column;
}

.visores__img {
  width: 99%;
  margin-right: 1%;
  margin-top: 6px;
  display: flex;
  flex-direction: column;
  margin-bottom: 10px;
}

.visores__img-eliminar {
  position: absolute;
  display: flex;
  align-items: center;
  cursor: pointer;
  top: 5px;
  right: 0;
  margin-right: 1rem;
}

.visores__img-eliminar > img {
  height: 0.9rem;
  margin-right: 3px;
  cursor: pointer;
}

.visores__img-eliminar > label {
  font-size: 13px;
  text-decoration: underline;
  cursor: pointer;
}

.visores__img > span {
  background-color: #f2f2f2;
  padding: 5px 0px;
  height: 24px;
  font-family: "AvenirNextLTPro-Medium";
  position: relative;
}

.visores__img > div {
  border-style: solid;
  border-color: #cccccc;
  border-width: 0px 1px 1px 1px;
  padding: 10px 10px;
  min-height: 280px;
  max-height: 280px;
  overflow-y: auto;
  overflow-x: auto;
  background-color: #ffff;
}

.visores__img > div > img {
  width: 90%;
}

.visores__comentarios {
  display: flex;
  flex-direction: column;
}

.avanzar-img > img {
  cursor: pointer;
}

.btnArchivos {
  position: relative;
  display: flex;
  flex-direction: column;
}

.btnArchivos > input[type="file"] {
  opacity: 0;
  z-index: 1;
  cursor: pointer;
  height: 100%;
}

.btnArchivos > label {
  position: absolute;
}

.comentariosVisor {
  font-size: 14px;
  text-align: left;
  margin: 10px 0px;
  display: flex !important;
  flex-direction: column;
  position: relative;
}

.comentariosVisor small {
  color: #b8b8b8;
  font-size: 12px;
  margin-bottom: 1rem;
}

.icoVisor {
  width: 100%;
}

.txtMotivo {
  background-color: #fac598;
  margin-bottom: 20px;
}

.visor__lateral > div img {
  width: 100%;
}

@media screen and (max-width: 960px) {
  .visor__lateral {
    display: flex;
    flex-direction: row-reverse;
    min-width: 600px;
  }

  .visor__lateral > div {
    padding: 0px 10px 5px 0px;
  }

  .visor__lateral > div img {
    width: 100%;
  }
}
</style>